
object Anchor {

  def create (p:Point):Anchor = new AnchorRepr(p)

  private class AnchorRepr (p:Point) extends Anchor {

    // var indicates that the field can be reassigned a new value
    var pos = p

    def position ():Point = pos
    
    def move (dx:Double, dy:Double):Unit = 
      pos = pos.move(dx,dy)    // move point and reassign pos to be that point

    override def toString ():String = "anchor(" + pos + ")"
  }
}


abstract class Anchor {

  def position ():Point
  def move (dx:Double, dy:Double):Unit 

}
